<style src="./Style.scss" lang="scss" scoped></style>
<script src="./Script.js"></script>

<template>
  <div
    class="modal animated fadeInRight s--modal s--modal-import s--modal-right"
    data-backdrop="static"
    data-keyboard="false"
    id="importDeal"
  >
    <div class="modal-dialog modal-dialog-centered d-none d-md-flex" style="max-width: 100%">
      <div class="modal-content">
        <div class="modal-header">
          <div class="container">
            <div
              class="d-flex align-items-center justify-content-around position-relative w-75 m-auto"
            >
              <div class="connector d-flex">
                <div
                  v-for="index in (steps.length - 1)"
                  :key="index"
                  :class="{ 'done': steps[index].isDone }"
                ></div>
              </div>
              <div class="step" v-for="(step, index) in steps" :key="index">
                <div
                  class="step-icon d-flex align-items-center justify-content-center"
                  :class="{ 'done': step.isDone }"
                >
                  <i class="icon" :class="step.icon"></i>
                </div>
                <div class="step-name">
                  Bước {{ index + 1 }}:
                  <b>{{ step.name }}</b>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="modal-body" data-scrollable="true" data-scrollbar-shown="true">
          <div
            class="container d-flex align-items-center justify-content-center"
            style="min-height: 100%"
          >
            <div class="row w-100" v-if="currentStep === 1">
              <h2 class="col-12 header">Import danh sách giao dịch</h2>
<!--              <div class="col-md-3">-->
<!--                <router-link to="deals/convert-file" target="_blank">-->
<!--                  <div class="import-box">-->
<!--                    <div class="import-box-header">Convert file mẫu</div>-->
<!--                    <div class="import-box-icon">-->
<!--                      <i class="far fa-file"></i>-->
<!--                    </div>-->
<!--                  </div>-->
<!--                </router-link>-->
<!--              </div>-->
              <div class="col-md-4">
                <div class="import-box" @click="downloadFileDefault()">
                  <div class="import-box-header">Download file mẫu</div>
                  <div class="import-box-icon">
                    <i class="icon icon-download"></i>
                  </div>
                </div>
              </div>
              <div class="col-md-4">
                <router-link to="deals/custom" target="_blank">
                  <div class="import-box">
                    <div class="import-box-header">Tạo file mẫu</div>
                    <div class="import-box-icon">
                      <i class="icon icon-plus"></i>
                    </div>
                  </div>
                </router-link>
              </div>
              <div class="col-md-4">
                <div
                  class="import-box"
                  :class="{ 'disabled': isDisabledUpload }"
                  @click="$refs.uploadFile.click()"
                >
                  <div class="import-box-header">Upload file</div>
                  <div class="import-box-icon special" v-if="!isDisabledUpload">
                    <i class="icon icon-upload"></i>
                  </div>
                  <div class="sk-circle" v-if="isDisabledUpload">
                    <div class="sk-circle1 sk-child"></div>
                    <div class="sk-circle2 sk-child"></div>
                    <div class="sk-circle3 sk-child"></div>
                    <div class="sk-circle4 sk-child"></div>
                    <div class="sk-circle5 sk-child"></div>
                    <div class="sk-circle6 sk-child"></div>
                    <div class="sk-circle7 sk-child"></div>
                    <div class="sk-circle8 sk-child"></div>
                    <div class="sk-circle9 sk-child"></div>
                    <div class="sk-circle10 sk-child"></div>
                    <div class="sk-circle11 sk-child"></div>
                    <div class="sk-circle12 sk-child"></div>
                  </div>
                </div>
                <div
                  v-if="dealFile.name"
                  class="m--margin-top-5 text-center w-75 m-auto"
                >{{ dealFile.name }}</div>
                <input
                  type="file"
                  style="visibility: hidden"
                  accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel"
                  ref="uploadFile"
                  @change.prevent="dealUploadOnFileChange($event)"
                />
              </div>
              <div class="col-12" v-if="errorMessage">
                <div class="error-box d-flex">
                  <i class="icon icon-warning"></i>
                  <div class="message">
                    <div class="error-header">Thông báo</div>
                    <div v-html="errorMessage"></div>
                  </div>
                </div>
              </div>
            </div>
            <div class="row" v-else-if="currentStep === 2">
              <div v-if="numberOfSuccessesImported === numberOfDeals" class="col-12">
                <h2 class="header">
                  Kết quả đạt
                  <span class="success-import">{{ numberOfSuccessesImported }}</span>
                  /{{ numberOfDeals }} giao dịch
                </h2>
                <div class="download-desc text-center">Chọn nút "Tiếp theo" để hoàn thành.</div>
              </div>
              <template v-else>
                <div class="col-12">
                  <h2 class="header">
                    Kết quả đạt
                    <span class="success-import">{{ numberOfSuccessesImported }}</span>
                    /{{ numberOfDeals }} giao dịch
                  </h2>
                  <div class="text-center">
                    <span class="download-report" @click="downloadResult">
                      <i class="icon icon-download"></i>
                      Tải xuống tệp kết quả
                    </span>
                  </div>
                  <div class="download-desc text-center">(Có mô tả lỗi sai)</div>
                </div>
                <div class="col-md-4 offset-md-2">
                  <div
                    class="import-box"
                    :class="{ 'selected': selectedOption === uploadOption.continue, 'disabled': !numberOfSuccessesImported }"
                    @click="selectedOption = uploadOption.continue"
                  >
                    <div class="import-box-header">Tiếp tục import dữ liệu đạt</div>
                    <div class="import-box-icon">
                      <i class="icon icon-book"></i>
                    </div>
                  </div>
                </div>
                <div class="col-md-4">
                  <div
                    class="import-box"
                    :class="{ 'selected': selectedOption === uploadOption.reupload }"
                    @click="selectedOption = uploadOption.reupload; isDisabledNext = true"
                  >
                    <div class="import-box-header">Upload lại file</div>
                    <div
                      class="import-box-icon"
                      :class="{ 'disabled': isDisabledUpload }"
                      v-if="!isDisabledUpload"
                    >
                      <i class="icon icon-edit"></i>
                    </div>
                    <div class="sk-circle" v-if="isDisabledUpload">
                      <div class="sk-circle1 sk-child"></div>
                      <div class="sk-circle2 sk-child"></div>
                      <div class="sk-circle3 sk-child"></div>
                      <div class="sk-circle4 sk-child"></div>
                      <div class="sk-circle5 sk-child"></div>
                      <div class="sk-circle6 sk-child"></div>
                      <div class="sk-circle7 sk-child"></div>
                      <div class="sk-circle8 sk-child"></div>
                      <div class="sk-circle9 sk-child"></div>
                      <div class="sk-circle10 sk-child"></div>
                      <div class="sk-circle11 sk-child"></div>
                      <div class="sk-circle12 sk-child"></div>
                    </div>
                  </div>
                </div>
                <div class="col-md-10 offset-md-2">
                  <div class="note">
                    <div v-if="selectedOption === uploadOption.reupload">
                      <p>
                        <b>Bạn vui lòng làm theo bước sau:</b>
                      </p>
                      <p>
                        Bước 1: Chọn
                        <b>"Tải xuống tệp kết quả"</b> để xem và sửa lỗi sai theo mẫu.
                      </p>
                      <div class="d-flex">
                        <div>Bước 2:</div>
                        <div>
                          <div class="link" @click="$refs.reuploadFile.click()">
                            <i class="icon icon-upload"></i>
                            Upload lại file đã sửa
                          </div>
                          <div
                            class="reupload-file d-inline-block"
                            v-if="reuploadFile.name"
                          >{{ reuploadFile.name }}</div>
                          <div class="error-message" v-if="errorMessage">{{ errorMessage }}</div>
                        </div>
                      </div>
                      <p style="margin-top: 1rem">
                        Bước 3: Chọn nút
                        <b>"Tiếp theo"</b> để hoàn thành.
                      </p>
                    </div>
                    <div v-else>
                      <p>
                        <b>Chú ý:</b>
                      </p>
                      <p>
                        Nếu bạn muốn import ngay dữ liệu đạt, vui lòng chọn
                        <b>"Tiếp theo"</b>
                      </p>
                      <p>
                        Nếu bạn muốn sửa và import lại file, vui lòng chọn
                        <b>"Upload lại file"</b>
                      </p>
                    </div>
                  </div>
                  <input
                    type="file"
                    style="visibility: hidden"
                    accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel"
                    ref="reuploadFile"
                    @change.prevent="onReuploadChange($event)"
                  />
                </div>
              </template>
            </div>
            <div v-else class="text-center">
              <div class="header">
                Đã thêm mới thành công
                <span class="success-import">{{ numberOfSuccessesImported }}</span> giao dịch
              </div>
              <button
                type="button"
                class="btn btn-back-deal"
                data-dismiss="modal"
                @click="onCancel"
              >
                <i class="icon icon-angle-left"></i>
                Trở về màn hình danh sách giao dịch
              </button>
            </div>
          </div>
        </div>
        <div class="modal-footer position-relative" v-if="currentStep !== steps.length">
          <div class="centering process">
            <span>Bước:</span>
            <b>{{ currentStep }}/{{ steps.length }}</b>
          </div>
          <button type="button" class="btn btn-back" v-if="!isHideBack" @click="onBack">
            <i class="icon icon-angle-left"></i>
            <span>Trở lại</span>
          </button>
          <button type="button" data-dismiss="modal" class="btn btn-cancel" @click="onCancel">Huỷ bỏ</button>
          <vue-ladda
            type="button"
            class="btn btn-next"
            :loading="isLoadingNext"
            :disabled="isDisabledNext"
            @click="onNext"
          >
            <span>Tiếp theo</span>
            <i class="icon icon-angle-right" :class="{ 'd-none': isLoadingNext }"></i>
          </vue-ladda>
        </div>
      </div>
    </div>
  </div>
</template>
